function Copy(path) {
    var Edit = new TEdit(WeBuilder);
    Edit.Parent = WeBuilder;
    Edit.Text = path;
    Edit.SelectAll();
    Edit.CopyToClipboard();                                 
    delete Edit;
}

function FormatPathWithFTP(Path) {
    var m, poses;
    if (RegexMatchAll(Path, "^FTP\\:\\:.*?\\\\(.*)\\|(.*)$", false, m, poses)) {
        return _v(m, [0, 1]) + "/" + _v(m, [0, 2]);
    } else {
        return Path;
    }
}

function ExtractFilePathWithFTP(Path) {
    var m, poses;
    if (RegexMatchAll(Path, "^FTP\\:\\:.*?\\\\(.*)\\|", false, m, poses)) {
        return _v(m, [0, 1]);
    } else {
        return ExtractFilePath(Path);
    }
}

function ExtractFileNameWithFTP(Path) {
    var res = ExtractFileName(Path);
    var m, poses;
    if (RegexMatchAll(res, "^FTP\\:\\:(.*)", false, m, poses)) {
        return _v(m, [0, 1]);
    } else {
        return res;
    }
}

function GetFileName(Sender) {
    if (Sender.FileName != "")
        return Sender.FileName;
    return Sender.FtpFileName;
}

function CopyPath(Sender) {
    Copy(FormatPathWithFTP(GetFileName(Document)));
}

function CopyDir(Sender) {
    Copy(ExtractFilePathWithFTP(GetFileName(Document)));
}

function CopyFilename(Sender) {
    Copy(ExtractFileNameWithFTP(GetFileName(Document)));
}

function OnInstalled() {
  if (WeBuilder.BuildNumber < 185) {
    return "This plugin needs newer build to run.";
  }
}

Script.RegisterDocumentAction("", "Copy File Path", "", &CopyPath);
Script.RegisterDocumentAction("", "Copy File Directory", "", &CopyDir);
Script.RegisterDocumentAction("", "Copy File Name", "", &CopyFilename);
Script.ConnectSignal("installed", &OnInstalled);

